unit uPSI_umath;
{
   last six knight   , with aliases
}
interface
 
uses
   SysUtils
  ,Classes
  ,uPSComponent
  ,uPSRuntime
  ,uPSCompiler
  ;
 
type 
(*----------------------------------------------------------------------------*)
  TPSImport_umath = class(TPSPlugin)
  protected
    procedure CompileImport1(CompExec: TPSScript); override;
    procedure ExecImport1(CompExec: TPSScript; const ri: TPSRuntimeClassImporter); override;
  end;
 
 
{ compile-time registration functions }
procedure SIRegister_umath(CL: TPSPascalCompiler);

{ run-time registration functions }
procedure RIRegister_umath_Routines(S: TPSExec);

procedure Register;

implementation


uses
   utypes
  ,uminmax
  ,umath
  ;
 
 
procedure Register;
begin
  RegisterComponents('Pascal Script', [TPSImport_umath]);
end;

(* === compile-time registration functions === *)
(*----------------------------------------------------------------------------*)
procedure SIRegister_umath(CL: TPSPascalCompiler);
begin
 CL.AddDelphiFunction('Function uExpo( X : Float) : Float');
 CL.AddDelphiFunction('Function uExp2( X : Float) : Float');
 CL.AddDelphiFunction('Function uExp10( X : Float) : Float');
 CL.AddDelphiFunction('Function Exp2( X : Float) : Float');
 CL.AddDelphiFunction('Function Exp10( X : Float) : Float');
 CL.AddDelphiFunction('Function uLog( X : Float) : Float');
 CL.AddDelphiFunction('Function uLog2( X : Float) : Float');
 CL.AddDelphiFunction('Function uLog10( X : Float) : Float');
 CL.AddDelphiFunction('Function uLogA( X, A : Float) : Float');
 CL.AddDelphiFunction('Function LogA( X, A : Float) : Float');
 CL.AddDelphiFunction('Function uIntPower( X : Float; N : Integer) : Float');
 CL.AddDelphiFunction('Function uPower( X, Y : Float) : Float');
end;

(* === run-time registration functions === *)
(*----------------------------------------------------------------------------*)
procedure RIRegister_umath_Routines(S: TPSExec);
begin
 S.RegisterDelphiFunction(@Expo, 'uExpo', cdRegister);
 S.RegisterDelphiFunction(@Exp2, 'uExp2', cdRegister);
 S.RegisterDelphiFunction(@Exp10, 'uExp10', cdRegister);
 S.RegisterDelphiFunction(@Exp2, 'Exp2', cdRegister);
 S.RegisterDelphiFunction(@Exp10, 'Exp10', cdRegister);
 S.RegisterDelphiFunction(@Log, 'uLog', cdRegister);
 S.RegisterDelphiFunction(@Log2, 'uLog2', cdRegister);
 S.RegisterDelphiFunction(@Log10, 'uLog10', cdRegister);
 S.RegisterDelphiFunction(@LogA, 'uLogA', cdRegister);
 S.RegisterDelphiFunction(@LogA, 'LogA', cdRegister);
 S.RegisterDelphiFunction(@IntPower, 'uIntPower', cdRegister);
 S.RegisterDelphiFunction(@Power, 'uPower', cdRegister);
end;

 
 
{ TPSImport_umath }
(*----------------------------------------------------------------------------*)
procedure TPSImport_umath.CompileImport1(CompExec: TPSScript);
begin
  SIRegister_umath(CompExec.Comp);
end;
(*----------------------------------------------------------------------------*)
procedure TPSImport_umath.ExecImport1(CompExec: TPSScript; const ri: TPSRuntimeClassImporter);
begin
  //RIRegister_umath(ri);
  RIRegister_umath_Routines(CompExec.Exec); // comment it if no routines
end;
(*----------------------------------------------------------------------------*)
 
 
end.
